#!/bin/sh
#post-install script.
#Puppy Linux
#assume current directory is rootfs-complete, which has the final filesystem.
#this script is similar to the post-install scripts of the window managers.
#Keywords are located in the Help page and the lines uncommented.

WKGDIR="`pwd`"

CONFIGFILE="usr/share/doc/index.html"
CONFIGBASE="index.html"
echo "Configuring Puppy skeleton..."

#cleanup...
rm -f /tmp/fbvideomode.txt


#/tmp/keywords.txt has all the keywords read from file "keyword" in each package.
KEYWORDS="`cat /tmp/keywords.txt`"
NUMKEYS="`wc -w /tmp/keywords.txt | tr -s " " | cut -f 2 -d " "`"

#number lines in the config file...
NUMLINES="`wc -l $CONFIGFILE | tr -s " " | cut -f 2 -d " "`"

#update Puppy version number...
echo -n "$PUPPYVERSION" > etc/puppyversion
DIGIT1="`echo "$PUPPYVERSION" | cut -b 1`"
DIGIT2="`echo "$PUPPYVERSION" | cut -b 2`"
DIGIT3="`echo "$PUPPYVERSION" | cut -b 3`"
RIGHTVER="${DIGIT1}.${DIGIT2}${DIGIT3}"

echo "Configuring Puppy Help page..."

echo "Writing version number to Help page..."
#insert the version number into file...
EDITTEXT="s/PUPPYVERSION/$RIGHTVER/g"
cat $CONFIGFILE | sed -e "$EDITTEXT" > /tmp/puphelppage.htm
sync
cp -f /tmp/puphelppage.htm $CONFIGFILE
sync

#insert date into file...
echo "Writing the date to Help page..."
PUPPYDATE="`date | tr -s " " | cut -f 2,6 -d " "`"
EDITTEXT="s/PUPPYDATE/$PUPPYDATE/g"
cat $CONFIGFILE | sed -e "$EDITTEXT" > /tmp/puphelppage.htm
sync
cp -f /tmp/puphelppage.htm $CONFIGFILE
sync

##############

#v1.0.5
echo "The number of keywords to process is $NUMKEYS."
echo "Processing keywords (this may take awhile!)..."
cp -f ./usr/share/doc/index.html ./root0/.index.html
sync
for ONEKEY in $KEYWORDS
do
 #echo -n " $ONEKEY"
 /usr/sbin/fixmenus $WKGDIR/root0 $ONEKEY index
done
sync
cp -f ./root0/.index.html ./usr/share/doc/index.html
echo "...rootfs-complete/$CONFIGFILE file has been processed."


#echo "The default kernel for Puppy is vmlinuz."
echo -n "vmlinuz" > /tmp/vmlinuzforpup.txt
#note, createpuppy will read this.

#end#
