#!/bin/sh

# $Header: /xxx2.cgi /main/f2admintools/1 2000/12/06 15:54:0 bediger $

# Fully-qualified path names of certain key executables.
# If PATH env var is unset by HTTP daemon, or by mistake, these need to
# be fully qualified.  May change from platform to platform.

ENVPROG=/usr/bin/printenv
if [ ! -x "$ENVPROG" ]
then
	for DIR in /bin /usr/bin /usr/sbin
	do
		for FILE in printenv env
		do
			if [ -f $DIR/$FILE -a -x $DIR/$FILE ]
			then
				ENVPROG=$DIR/$FILE
			fi
		done
	done
fi

DATEPROG=/bin/date
if [ ! -x "$DATEPROG" ]
then
	DATEPROG=`which date 2>/dev/null`
fi

PWDPROG=/bin/pwd
if [ ! -x "$PWDPROG" ]
then
	PWDPROG=`which pwd 2>/dev/null`
fi



# what actually gets put on the output by the tty driver, eh?
echo 'Content-type: text/html
'
echo '
'

echo '<HTML><HEAD>'

if [ -n "$HTTP_REFERER" ]
then
	REFERER=`basename $HTTP_REFERER`
	echo "<TITLE>Refered from: $REFERER</TITLE>"
else
	echo '<TITLE>CGI Playground!!!!</TITLE>'
fi

echo '</HEAD><BODY>'
echo '<H1>CGI sh script - $Header: /xxx2.cgi /main/f2admintools/1 2000/12/06 15:54:0 bediger $</H1>'

UNAMEPROG=`which uname 2> /dev/null`
if [ -x "$UNAMEPROG" ]
then
	echo '<HR>'
	echo "<H2>System Type</H2>"
	echo '<PRE>'
	$UNAMEPROG -a
	echo '</PRE>'
fi

if [ -n "$REMOTE_HOST" ]
then
	echo "<HR><H2>Remote host at $REMOTE_HOST</H2>"
	NSLOOKUPPROG=`which nslookup 2>/dev/null`
	if [ -n "$NSLOOKUPPROG" ]
	then
		echo '<P><PRE>'
		$NSLOOKUPPROG $REMOTE_HOST 2>&1
		echo '</PRE></P>'
	fi
else
	echo '<H2>No remote host data</H2>'
fi
if [ -n "$REMOTE_ADDR" ]
then
	echo "<HR><H2>Remote address is $REMOTE_ADDR</H2>"
	NSLOOKUPPROG=`which nslookup 2>/dev/null`
	if [ -n "$NSLOOKUPPROG" ]
	then
		echo '<P><PRE>'
		$NSLOOKUPPROG $REMOTE_ADDR 2>&1
		echo '</PRE></P>'
	fi
fi


IDPROG=`which id 2>/dev/null`
WHOPROG=`which whoami 2>/dev/null`

if [ -x "$IDPROG" -o -x "$WHOPROG" ]
then
	echo '<HR>'
	echo "<H2>Identity of CGI-BIN program</H2>"
	if [ -x "$IDPROG" ]
	then
		echo "<P>id program ($IDPROG) says this ran as " `$IDPROG` "</P>"
	fi
	if [ -x "$WHOPROG" ]
	then
		echo "<P>whoami program ($WHOPROG) says this ran as " `$WHOPROG` "</P>"
	fi

	# Try one more stunt to get additional identity information
	WHOPROG=`which who 2>/dev/null`
	if [ -x "$WHOPROG" ]
	then
		WHO=`$WHOPROG am i 2>/dev/null`
		if [ ! -z "$WHO" ]
		then
			echo "<P>who am i says: $WHO</P>"
		fi
	fi
fi

echo '<HR>'

if [ -x "$PWDPROG" ]
then
	echo "<H2>Current Working Directory</H2>"
	echo "<P>pwd program ($PWDPROG) says working directory is &quot;`$PWDPROG`&quot;</P>"
else
	echo "<P>pwd program &quot;$PWDPROG&quot;</P> doesn't exist or is not marked executable"
fi

echo '<HR>'

# Solaris 2.6 and HP-UX 10.20 have "ulimit".  SunOS 4.1.3 does not.
# NetBSD 1.3.2 does not.  Red Hat Linux 5.0 does not.  Still, it's
# nice to know this stuff when you can.
LIMITPROG=`which ulimit 2>/dev/null`
if [ -x "$LIMITPROG" ]
then
	echo "<H2>Limits</H2>"
	echo '<PRE>'
	$LIMITPROG -a
	echo '</PRE>'
	echo '<HR>'
fi

QUOTAPROG=`which quota 2>/dev/null`
if [ -x "$QUOTAPROG" ]
then
	if [ -x "$PWDPROG" ]
	then
		CWD=`$PWDPROG`
		echo "<H2>Disk quota of $CWD</H2>"
	else
		echo "<H2>Disk quota</H2>"
	fi
	echo '<PRE>'
	$QUOTAPROG
	echo '</PRE>'
	echo '<HR>'
fi

DUPROG=`which du`
if [ -x "$DUPROG" ]
then
	CWD=
	echo "<H2>Disk usage</H2>"
	echo '<PRE>'
	$DUPROG -k -s
	echo '</PRE>'
	echo '<HR>'
fi

# This next information seems more useful under Solaris than Linux
if test -d /proc/$$/fd
then
	echo "<H2>File Descriptors</H2>"
	echo '<PRE>'
	for name in /proc/$$/fd/*
	do
    	file $name
	done
	echo '</PRE><HR>'
fi

if [ -x "$DATEPROG" ]
then
	echo "<H2>Time</H2>"
	echo  'Date on this server:  <STRONG>' `$DATEPROG` '</STRONG>'
	echo '<P>'
fi
echo '<HR>'

echo "<H2>HTTP Referrer</H2>"
if [ -n "$HTTP_REFERER" ]
then
	echo "Referred by $HTTP_REFERER"
else
	echo "No HTTP referrer data"
fi
echo '<HR>'

echo "<H2>Command line</H2>"
echo "<P>CGI-BIN program called as \"$0\"</P>"
echo "<PRE>"
if [ $# -gt 0 ]
then
	echo $*
else
	echo "No arguments"
fi
echo "</PRE>"
echo '<HR>'
echo "<H2>CGI Specified environment variables</H2>"
echo "<TABLE BORDER=1>"
echo "<TR><TD>SERVER_SOFTWARE</TD><TD>$SERVER_SOFTWARE</TD></TR>"
echo "<TR><TD>SERVER_NAME</TD><TD>$SERVER_NAME</TD></TR>"
echo "<TR><TD>GATEWAY_INTERFACE</TD><TD>$GATEWAY_INTERFACE</TD></TR>"
echo "<TR><TD>SERVER_PROTOCOL</TD><TD>$SERVER_PROTOCOL</TD></TR>"
echo "<TR><TD>SERVER_PORT</TD><TD>$SERVER_PORT</TD></TR>"
echo "<TR><TD>REQUEST_METHOD</TD><TD>$REQUEST_METHOD</TD></TR>"
echo "<TR><TD>PATH_INFO</TD><TD>$PATH_INFO</TD></TR>"
echo "<TR><TD>PATH_TRANSLATED</TD><TD>$PATH_TRANSLATED</TD></TR>"
echo "<TR><TD>SCRIPT_NAME</TD><TD>$SCRIPT_NAME</TD></TR>"
echo "<TR><TD>QUERY_STRING</TD><TD>$QUERY_STRING</TD></TR>"
echo "<TR><TD>REMOTE_HOST</TD><TD>$REMOTE_HOST</TD></TR>"
echo "<TR><TD>REMOTE_ADDR</TD><TD>$REMOTE_ADDR</TD></TR>"
echo "<TR><TD>AUTH_TYPE</TD><TD>$AUTH_TYPE</TD></TR>"
echo "<TR><TD>REMOTE_USER</TD><TD>$REMOTE_USER</TD></TR>"
echo "<TR><TD>REMOTE_IDENT</TD><TD>$REMOTE_IDENT</TD></TR>"
echo "<TR><TD>CONTENT_TYPE</TD><TD>$CONTENT_TYPE</TD></TR>"
echo "<TR><TD>CONTENT_LENGTH</TD><TD>$CONTENT_LENGTH</TD></TR>"
echo "<TR><TD>HTTP_ACCEPT</TD><TD>$HTTP_ACCEPT</TD></TR>"
echo "<TR><TD>HTTP_USER_AGENT</TD><TD>$HTTP_USER_AGENT</TD></TR>"
echo "</TABLE>"
echo '<HR>'

echo "<H2>All Environment variables</H2>"
if [ -x "$ENVPROG" ]
then
	echo "<PRE>"

	if $ENVPROG 2>&1
	then
		echo 
	else
		echo "<STRONG>Printing environment variables failed: printenv returned \"$?\"</STRONG>"
	fi
	echo "</PRE>"
else
	echo "<P>Environment printing program \"$ENVPROG\" missing or not marked executable</P>"
fi
echo '<HR>'

TIMEOUT=""

echo "<H2>Request method: $REQUEST_METHOD</H2>"
if [ "$REQUEST_METHOD" = "POST" ]
then
	echo "<H2>Apparently called by a POST, here's what's on stdin:</H2>"
	echo "<PRE>"
	cat > /tmp/post_$$
	cat /tmp/post_$$
	echo "</PRE>"

	echo '<H4>stdin massaged into lines</H4>'
	echo '<P>'
	echo "<PRE>"
	#./url_decode.pl `cat /tmp/post_$$`
	cat /tmp/post_$$ | tr '&+' '\012 '
	echo ""
	echo "</PRE>"

	echo "<P>CONTENT_LENGTH is $CONTENT_LENGTH.<BR>"
	echo "  Count of chars on stdin: " `cat /tmp/post_$$ | wc -c` '</P>'

	echo >> /tmp/post_$$;  # see if you can guess what this does

	# Hidden bonus function: if url-encoded name/value pair with name 'timeout'
	# exists, sleep for as man seconds as that pair's value part.
	TIMEOUT=`cat /tmp/post_$$ | tr '&+' '\012 ' | grep 'timeout=' |sed 's/timeout=//'`

	rm /tmp/post_$$;

elif [ "$REQUEST_METHOD" = "GET" ]
then

	echo '<H2>Apparently called by a GET</H2>'
	if [ -n "$QUERY_STRING" ]
	then
		echo "<P>QUERY_STRING is &quot;$QUERY_STRING&quot;</P>"
		echo '<H4>QUERY_STRING massaged into lines</H4><P><PRE>'
		echo "$QUERY_STRING" | tr '&+' '\012 '
		#echo ""
		#./url_decode.pl "$QUERY_STRING"
		echo "</PRE></P>"
	else
		echo "<P>No or zero-length QUERY_STRING</P>"
	fi

	TIMEOUT=`echo "$QUERY_STRING" | tr '&+' '\012 ' | grep 'timeout=' |sed 's/timeout=//'`

else
	echo '<H2>' "Some unknown REQUEST_METHOD: \"$REQUEST_METHOD\"" '</H2>'
fi
echo '<HR>'

if [ ! -z "$TIMEOUT" ]
then
	echo "<P>Sleeping for $TIMEOUT seconds<BR>"
	sleep $TIMEOUT
	echo "<H4>Done!</H4></P>"
fi

echo "</BODY>"
echo "</HTML>"
exit 0
