#!/bin/sh

PUPPYVERSION="`cat /etc/puppyversion`"

PRINFO="If you cannot see an your printer in the Printer Wizard
driver selection-window, look through here.

EXTRACT FROM GUTENPRINT DOCS:
The following printers are not all officially supported, but they have
been reported to work with the listed driver.  In some cases, they may
work incompletely, or they may not actually work at all. Thanks to
linuxprinting.org for this data.

    Printer Model    Driver     Compatible Printer

    Apollo P-2100    pcl-690    HP DeskJet 690 series
    Apollo P-2150    pcl-690    HP DeskJet 690 series
    Apollo P-2200    pcl-690    HP DeskJet 690 series
    Apollo P-2250    pcl-690    HP DeskJet 690 series
    Apollo P-2500    pcl-690    HP DeskJet 690 series
    Apollo P-2550    pcl-690    HP DeskJet 690 series
    Apollo P-2600    pcl-690    HP DeskJet 690 series
    Apollo P-2650    pcl-690    HP DeskJet 690 series
    Apple Color StyleWriter 4100    pcl-apple-4100    APPLE Color StyleWriter 4100
    Apple Color StyleWriter 4500    pcl-apple-4500    APPLE Color StyleWriter 4500
    Apple Color StyleWriter 6500    pcl-apple-6500    APPLE Color StyleWriter 6500
    Apple LaserWriter Select 360    pcl-2    HP LaserJet II series

    Brother DCP-1200  pcl-2    HP LaserJet II series
    Brother HL-4Ve    pcl-2    HP LaserJet II series
    Brother HL-10h    pcl-4    HP LaserJet 4 series
    Brother HL-10V    pcl-3    HP LaserJet III series
    Brother HL-630    pcl-2    HP LaserJet II series
    Brother HL-660    pcl-4    HP LaserJet 4 series
    Brother HL-760    pcl-4    HP LaserJet 4 series
    Brother HL-960    pcl-4    HP LaserJet 4 series
    Brother HL-1040   pcl-2    HP LaserJet II series
    Brother HL-1050   pcl-4    HP LaserJet 4 series
    Brother HL-1060   pcl-4    HP LaserJet 4 series
    Brother HL-1070   pcl-4    HP LaserJet 4 series
    Brother HL-1240   pcl-2    HP LaserJet II series
    Brother HL-1250   pcl-4    HP LaserJet 4 series
    Brother HL-1260   pcl-4    HP LaserJet 4 series
    Brother HL-1270N  pcl-4    HP LaserJet 4 series
    Brother HL-1440   pcl-4    HP LaserJet 4 series
    Brother HL-1660e  pcl-4    HP LaserJet 4 series
    Brother HL-2060   pcl-4    HP LaserJet 4 series
    Brother MFC-6550MC pcl-2    HP LaserJet II series
    Brother MFC-8300   pcl-3    HP LaserJet III series
    Brother MFC-9500   pcl-2    HP LaserJet II series
    Brother MFC-9600   pcl-2    HP LaserJet II series

    Canon BJ-30     bjc-30     CANON BJC 30
    Canon BJC-50    bjc-50     CANON BJC 50
    Canon BJC-55    bjc-55     CANON BJC 55
    Canon BJC-80    bjc-80     CANON BJC 80
    Canon BJC-85    bjc-85     CANON BJC 85
    Canon BJC-210   bjc-210    CANON BJC 210
    Canon BJC-240   bjc-240    CANON BJC 240
    Canon BJC-250   bjc-250    CANON BJC 250
    Canon BJC-1000  bjc-1000   CANON BJC 1000
    Canon BJC-2000  bjc-2000   CANON BJC 2000
    Canon BJC-2010  bjc-2000   CANON BJC 2000
    Canon BJC-2100  bjc-4300   CANON BJC 4300
    Canon BJC-2110  bjc-2000   CANON BJC 2000
    Canon BJC-3000  bjc-3000   CANON BJC 3000
    Canon BJC-4000  bjc-4300   CANON BJC 4300
    Canon BJC-4300  bjc-4300   CANON BJC 4300
    Canon BJC-4400  bjc-4400   CANON BJC 4400 photo
    Canon BJC-6000  bjc-6000   CANON BJC 6000
    Canon BJC-6100  bjc-6100   CANON BJC 6100
    Canon BJC-6200  bjc-6200   CANON BJC 6200
    Canon BJC-6500  bjc-6500   CANON BJC 6500
    Canon BJC-7000  bjc-7000   CANON BJC 7000
    Canon BJC-7100  bjc-7100   CANON BJC 7100
    Canon BJC-8200  bjc-8200   CANON BJC 8200
    Canon CP-100    canon-cp100  CANON CP100
    Canon CP-200    canon-cp100  CANON CP100
    Canon CP-300    canon-cp100  CANON CP100
    Canon GP 335    pcl-4      HP LaserJet 4 series
    Canon LBP-4sx   pcl-3      HP LaserJet III series
    Canon LBP-430   pcl-4l     HP LaserJet 4L
    Canon LBP-1000  pcl-6      HP LaserJet 6 series
    Canon LBP-1260  pcl-6      HP LaserJet 6 series
    Canon LBP-1760  pcl-6      HP LaserJet 6 series
    Canon S100      bjc-4300   CANON BJC 4300
    Canon S300      bjc-s800   CANON S800
    Canon S400      bjc-s400   CANON S400
    Canon S450      bjc-s450   CANON S450
    Canon S500      bjc-8200   CANON BJC 8200
    Canon S600      bjc-8200   CANON BJC 8200
    Canon S630      bjc-8200   CANON BJC 8200
    Canon S800      bjc-s800   CANON S800
    Canon S4500     bjc-s4500  CANON S4500
    Canon imageRunner 330s   pcl-4    HP LaserJet 4 series

    Citizen ProJet II    pcl-2    HP LaserJet II series

    DEC 1800        pcl-3      HP LaserJet III series
    DEC LN17        pcl-4      HP LaserJet 4 series

    Epson ActionLaser 1100   pcl-3    HP LaserJet III series
    Epson ActionLaser II     pcl-2    HP LaserJet II series
    Epson AcuLaser C2000     pcl-4    HP LaserJet 4 series
    Epson AcuLaser C2000PS   pcl-4    HP LaserJet 4 series
    Epson AcuLaser C8500     pcl-4    HP LaserJet 4 series
    Epson AcuLaser C8500PS   pcl-4    HP LaserJet 4 series
    Epson AcuLaser C8600     pcl-4    HP LaserJet 4 series
    Epson AcuLaser C8600PS   pcl-4    HP LaserJet 4 series
    Epson EPL-5200           pcl-3    HP LaserJet III series
    Epson EPL-5200+          pcl-3    HP LaserJet III series
    Epson EPL-5700           pcl-4    HP LaserJet 4 series
    Epson EPL-5700PS         pcl-4    HP LaserJet 4 series
    Epson EPL-5800           pcl-4    HP LaserJet 4 series
    Epson EPL-5800PS         pcl-4    HP LaserJet 4 series
    Epson EPL-5900           pcl-4    HP LaserJet 4 series
    Epson EPL-5900PS         pcl-4    HP LaserJet 4 series
    Epson EPL-6100           pcl-4    HP LaserJet 4 series
    Epson EPL-6100PS         pcl-4    HP LaserJet 4 series
    Epson EPL-7100           pcl-2    HP LaserJet II series
    Epson Stylus C20SX    escp2-c20sx    EPSON Stylus C20SX
    Epson Stylus C20UX    escp2-c20ux    EPSON Stylus C20UX
    Epson Stylus C40SX    escp2-c40sx    EPSON Stylus C40SX
    Epson Stylus C40UX    escp2-c40ux    EPSON Stylus C40UX
    Epson Stylus C41SX    escp2-c41sx    EPSON Stylus C41SX
    Epson Stylus C41UX    escp2-c41ux    EPSON Stylus C41UX
    Epson Stylus C42SX    escp2-c42sx    EPSON Stylus C42SX
    Epson Stylus C42UX    escp2-c42ux    EPSON Stylus C42UX
    Epson Stylus C43SX    escp2-c43sx    EPSON Stylus C43SX
    Epson Stylus C43UX    escp2-c43ux    EPSON Stylus C43UX
    Epson Stylus C44SX    escp2-c44sx    EPSON Stylus C44SX
    Epson Stylus C44UX    escp2-c44ux    EPSON Stylus C44UX
    Epson Stylus C50      escp2-c50      EPSON Stylus C50
    Epson Stylus C60      escp2-c60      EPSON Stylus C60
    Epson Stylus C61      escp2-c61      EPSON Stylus C61
    Epson Stylus C62      escp2-c62      EPSON Stylus C62
    Epson Stylus C63      escp2-c63      EPSON Stylus C63
    Epson Stylus C64      escp2-c64      EPSON Stylus C64
    Epson Stylus C70      escp2-c70      EPSON Stylus C70
    Epson Stylus C80      escp2-c80      EPSON Stylus C80
    Epson Stylus C82      escp2-c82      EPSON Stylus C82
    Epson Stylus C83      escp2-c83      EPSON Stylus C83
    Epson Stylus C84      escp2-c84      EPSON Stylus C84
    Epson Stylus Color      escp2        EPSON Stylus Color
    Epson Stylus Color I    escp2        EPSON Stylus Color
    Epson Stylus Color II   escp2        EPSON Stylus Color
    Epson Stylus Color IIs  escp2        EPSON Stylus Color
    Epson Stylus Color PRO  escp2-pro    EPSON Stylus Color Pro
    Epson Stylus Color Pro XL   escp2-pro-xl   EPSON Stylus Color Pro XL
    Epson Stylus Color 400      escp2-400      EPSON Stylus Color 400
    Epson Stylus Color 440      escp2-440      EPSON Stylus Color 440
    Epson Stylus Color 460      escp2-460      EPSON Stylus Color 460
    Epson Stylus Color 480      escp2-480      EPSON Stylus Color 480
    Epson Stylus Color 500      escp2-500      EPSON Stylus Color 500
    Epson Stylus Color 580      escp2-580      EPSON Stylus Color 580
    Epson Stylus Color 600      escp2-600      EPSON Stylus Color 600
    Epson Stylus Color 640      escp2-640      EPSON Stylus Color 640
    Epson Stylus Color 660      escp2-660      EPSON Stylus Color 660
    Epson Stylus Color 670      escp2-670      EPSON Stylus Color 670
    Epson Stylus Color 680      escp2-680      EPSON Stylus Color 680
    Epson Stylus Color 740      escp2-740      EPSON Stylus Color 740
    Epson Stylus Color 760      escp2-760      EPSON Stylus Color 760
    Epson Stylus Color 777      escp2-777      EPSON Stylus Color 777
    Epson Stylus Color 8 3      escp2-83       EPSON Stylus Color 83
    Epson Stylus Color 800      escp2-800      EPSON Stylus Color 800
    Epson Stylus Color 850      escp2-850      EPSON Stylus Color 850
    Epson Stylus Color 860      escp2-860      EPSON Stylus Color 860
    Epson Stylus Color 880      escp2-880      EPSON Stylus Color 880
    Epson Stylus Color 900      escp2-900      EPSON Stylus Color 900
    Epson Stylus Color 980      escp2-980      EPSON Stylus Color 980
    Epson Stylus Color 1160     escp2-1160     EPSON Stylus Color 1160
    Epson Stylus Color 1500     escp2-1500     EPSON Stylus Color 1500
    Epson Stylus Color 1520     escp2-1520     EPSON Stylus Color 1520
    Epson Stylus Color 3000     escp2-3000     EPSON Stylus Color 3000
    Epson Stylus Photo          escp2-photo    EPSON Stylus Photo
    Epson Stylus Photo 700      escp2-700      EPSON Stylus Photo 700
    Epson Stylus Photo 720      escp2-720      EPSON Stylus Photo 720
    Epson Stylus Photo 750      escp2-750      EPSON Stylus Photo 750
    Epson Stylus Photo 780      escp2-780      EPSON Stylus Photo 780
    Epson Stylus Photo 785      escp2-785      EPSON Stylus Photo 785EPX
    Epson Stylus Photo 790      escp2-790      EPSON Stylus Photo 790
    Epson Stylus Photo 810      escp2-810      EPSON Stylus Photo 810
    Epson Stylus Photo 820      escp2-820      EPSON Stylus Photo 820
    Epson Stylus Photo 825      escp2-825      EPSON Stylus Photo 825
    Epson Stylus Photo 830      escp2-830      EPSON Stylus Photo 830
    Epson Stylus Photo 870      escp2-870      EPSON Stylus Photo 870
    Epson Stylus Photo 875      escp2-875      EPSON Stylus Photo 875
    Epson Stylus Photo 890      escp2-890      EPSON Stylus Photo 890
    Epson Stylus Photo 895      escp2-895      EPSON Stylus Photo 895
    Epson Stylus Photo 900      escp2-ph900    EPSON Stylus Photo 900
    Epson Stylus Photo 915      escp2-915      EPSON Stylus Photo 915
    Epson Stylus Photo 925      escp2-925      EPSON Stylus Photo 925
    Epson Stylus Photo 935      escp2-935      EPSON Stylus Photo 935
    Epson Stylus Photo 950      escp2-950      EPSON Stylus Photo 950
    Epson Stylus Photo 960      escp2-960      EPSON Stylus Photo 960
    Epson Stylus Photo 1200     escp2-1200     EPSON Stylus Photo 1200
    Epson Stylus Photo 1270     escp2-1270     EPSON Stylus Photo 1270
    Epson Stylus Photo 1280     escp2-1280     EPSON Stylus Photo 1280
    Epson Stylus Photo 1290     escp2-1290     EPSON Stylus Photo 1290
    Epson Stylus Photo 2000P    escp2-2000     EPSON Stylus Photo 2000P
    Epson Stylus Photo 2100     escp2-2100     EPSON Stylus Photo 2100
    Epson Stylus Photo 2200     escp2-2200     EPSON Stylus Photo 2200
    Epson Stylus Photo EX       escp2-ex       EPSON Stylus Photo EX
    Epson Stylus Photo EX3      escp2-ex3      EPSON Stylus Photo EX3
    Epson Stylus Photo R300     escp2-r300     EPSON Stylus Photo R300
    Epson Stylus Pro 5000       escp2-5000     EPSON Stylus Pro 5000
    Epson Stylus Pro 5500       escp2-5500     EPSON Stylus Pro 5500
    Epson Stylus Pro 7000       escp2-7000     EPSON Stylus Pro 7000
    Epson Stylus Pro 7500       escp2-7500     EPSON Stylus Pro 7500
    Epson Stylus Pro 7600       escp2-7600     EPSON Stylus Pro 7600
    Epson Stylus Pro 9000       escp2-9000     EPSON Stylus Pro 9000
    Epson Stylus Pro 9500       escp2-9500     EPSON Stylus Pro 9500
    Epson Stylus Pro 9600       escp2-9600     EPSON Stylus Pro 9600
    Epson Stylus Pro 10000      escp2-10000    EPSON Stylus Pro 10000
    Epson Stylus Scan 2000      escp2-scan2000 EPSON Stylus Scan 2000
    Epson Stylus Scan 2500      escp2-scan2500 EPSON Stylus Scan 2500
    Epson Stylus CX3100         escp2-cx3100   EPSON Stylus CX-3100
    Epson Stylus CX3200         escp2-cx3200   EPSON Stylus CX-3200
    Epson Stylus CX5100         escp2-cx5100   EPSON Stylus CX-5100
    Epson Stylus CX5200         escp2-cx5200   EPSON Stylus CX-5200
    Epson Stylus CX6300         escp2-cx6300   EPSON Stylus CX-6300
    Epson Stylus CX6400         escp2-cx6400   EPSON Stylus CX-6400
    Epson Stylus CX8300         escp2-cx8300   EPSON Stylus CX-8300
    Epson Stylus CX8400         escp2-cx8400   EPSON Stylus CX-8400
    Epson CL-700                escp2-cl700    EPSON CL-700
    Epson CL-750                escp2-cl750    EPSON CL-750
    Epson CL-760                escp2-cl760    EPSON CL-760
    Epson EM-900C               escp2-em900c   EPSON EM-900C
    Epson EM-930C               escp2-em930c   EPSON EM-930C
    Epson MC-2000               escp2-mc2000   EPSON MC-2000
    Epson MC-5000               escp2-mc5000   EPSON MC-5000
    Epson MC-7000               escp2-mc7000   EPSON MC-7000
    Epson MC-9000               escp2-mc9000   EPSON MC-9000
    Epson MC-10000              escp2-mc10000  EPSON MC-10000
    Epson MJ-930C               escp2-mj930c   EPSON MJ-930C
    Epson MJ-5100C              escp2-mj5100c  EPSON MJ-5100C
    Epson MJ-6000C              escp2-mj6000c  EPSON MJ-6000C
    Epson MJ-8000C              escp2-mj8000c  EPSON MJ-8000C
    Epson PM-700C               escp2-pm700c   EPSON PM-700C
    Epson PM-G700               escp2-pmg700   EPSON PM-G700
    Epson PM-730C               escp2-pm730c   EPSON PM-730C
    Epson PM-740C               escp2-pm740c   EPSON PM-740C
    Epson PM-750C               escp2-pm750c   EPSON PM-750C
    Epson PM-D750               escp2-pmd750   EPSON PM-D750
    Epson PM-760C               escp2-pm760c   EPSON PM-760C
    Epson PM-770C               escp2-pm770c   EPSON PM-770C
    Epson PM-780C               escp2-pm780c   EPSON PM-780C
    Epson PM-790PT              escp2-pm790pt  EPSON PM-790PT
    Epson PM-800C               escp2-pm800c   EPSON PM-800C
    Epson PM-G800               escp2-pmg800   EPSON PM-G800
    Epson PM-850PT              escp2-pm850pt  EPSON PM-850PT
    Epson PM-870C               escp2-pm870c   EPSON PM-870C
    Epson PM-880C               escp2-pm880c   EPSON PM-880C
    Epson PM-930C               escp2-pm930c   EPSON PM-930C
    Epson PM-940C               escp2-pm940c   EPSON PM-940C
    Epson PM-950C               escp2-pm950c   EPSON PM-950C
    Epson PM-970C               escp2-pm970c   EPSON PM-970C
    Epson PM-980C               escp2-pm980c   EPSON PM-980C
    Epson PM-2000C              escp2-pm2000c  EPSON PM-2000C
    Epson PM-2200C              escp2-pm2200c  EPSON PM-2200C
    Epson PM-3000C              escp2-pm3000c  EPSON PM-3000C
    Epson PM-3300C              escp2-pm3300c  EPSON PM-3300C
    Epson PM-3500C              escp2-pm3500c  EPSON PM-3500C
    Epson PM-3700C    escp2-pm3700c    EPSON PM-3700C
    Epson PM-4000PX   escp2-pm4000px   EPSON PM-4000PX
    Epson PM-5000C    escp2-pm5000c    EPSON PM-5000C
    Epson PM-7000C    escp2-pm7000c    EPSON PM-7000C
    Epson PM-9000C    escp2-pm9000c    EPSON PM-9000C
    Epson PM-10000    escp2-pm10000    EPSON PM-10000
    Epson PX-V500     escp2-pxv500     EPSON PX-V500
    Epson PX-7000     escp2-px7000     EPSON PX-7000
    Epson PX-9000     escp2-px9000     EPSON PX-9000

    Fujifilm CX-400            fujifilm-cx400  FUJIFILM CX-400
    Fujitsu PrintPartner 10V   pcl-4           HP LaserJet 4 series
    Fujitsu PrintPartner 16DV  pcl-4           HP LaserJet 4 series
    Fujitsu PrintPartner 20W   pcl-6           HP LaserJet 6 series
    Fujitsu PrintPartner 8000  pcl-3           HP LaserJet III series

    HP 2000C                   pcl-2000    HP DeskJet 2000 series
    HP 2500C                   pcl-2500    HP DeskJet 2500 series
    HP 2500CM                  pcl-2500    HP DeskJet 2500 series
    HP Business Inkjet 2200    pcl-900     HP DeskJet 900 series
    HP Business Inkjet 2230    pcl-900     HP DeskJet 900 series
    HP Business Inkjet 2250    pcl-900     HP DeskJet 900 series
    HP Business Inkjet 2250TN  pcl-900     HP DeskJet 900 series
    HP Business Inkjet 2280    pcl-900     HP DeskJet 900 series
    HP Color Inkjet Printer CP1160    pcl-900    HP DeskJet 900 series
    HP Color Inkjet Printer CP1700    pcl-900    HP DeskJet 900 series
    HP Color LaserJet 5        pcl-3    HP LaserJet III series
    HP Color LaserJet 2500     pcl-4    HP LaserJet 4 series
    HP Color LaserJet 4500     pcl-4    HP LaserJet 4 series
    HP Color LaserJet 4550     pcl-4    HP LaserJet 4 series
    HP Color LaserJet 4600     pcl-4    HP LaserJet 4 series
    HP Color LaserJet 5000     pcl-4    HP LaserJet 4 series
    HP Color LaserJet 5500     pcl-4    HP LaserJet 4 series
    HP Color LaserJet 8550GN   pcl-4    HP LaserJet 4 series
    HP DesignJet 230           pcl-desnj-230    HP DesignJet 230
    HP DesignJet 250C          pcl-desnj-250    HP DesignJet 250C
    HP DesignJet 430           pcl-desnj-430    HP DesignJet 430
    HP DesignJet 450C          pcl-desnj-450    HP DesignJet 450C
    HP DesignJet 455CA         pcl-desnj-455    HP DesignJet 455CA
    HP DesignJet 488CA         pcl-desnj-488    HP DesignJet 488CA
    HP DesignJet 700           pcl-desnj-700    HP DesignJet 700
    HP DesignJet 750C          pcl-750          HP DesignJet 750C
    HP DesignJet 750C Plus     pcl-750          HP DesignJet 750C
    HP DesignJet 2500CP        pcl-desnj-2500   HP DesignJet 2500C
    HP DesignJet 3500CP        pcl-desnj-3500   HP DesignJet 3500C
    HP DesignJet ColorPro CAD  pcl-2500         HP DeskJet 2500 series
    HP DeskJet 340C            pcl-340    HP DeskJet 340
    HP DeskJet 400             pcl-400    HP DeskJet 400
    HP DeskJet 400C            pcl-540    HP DeskJet 540C
    HP DeskJet 420C            pcl-540    HP DeskJet 540C
    HP DeskJet 450             pcl-900    HP DeskJet 900 series
    HP DeskJet 500             pcl-500    HP DeskJet 500
    HP DeskJet 500C            pcl-501    HP DeskJet 500C
    HP DeskJet 505J Plus       pcl-500    HP DeskJet 500
    HP DeskJet 510             pcl-500    HP DeskJet 500
    HP DeskJet 520             pcl-520    HP DeskJet 520
    HP DeskJet 540C            pcl-540    HP DeskJet 540C
    HP DeskJet 550C            pcl-550    HP DeskJet 550C
    HP DeskJet 560C            pcl-560    HP DeskJet 560C
    HP DeskJet 600             pcl-600    HP DeskJet 600/600C
    HP DeskJet 610C            pcl-601    HP DeskJet 600 series
    HP DeskJet 610CL           pcl-601    HP DeskJet 600 series
    HP DeskJet 612C            pcl-601    HP DeskJet 600 series
    HP DeskJet 640C            pcl-601    HP DeskJet 600 series
    HP DeskJet 648C            pcl-601    HP DeskJet 600 series
    HP DeskJet 660C            pcl-601    HP DeskJet 600 series
    HP DeskJet 670C            pcl-601    HP DeskJet 600 series
    HP DeskJet 670TV           pcl-601    HP DeskJet 600 series
    HP DeskJet 672C            pcl-601    HP DeskJet 600 series
    HP DeskJet 680C            pcl-601    HP DeskJet 600 series
    HP DeskJet 682C      pcl-601    HP DeskJet 600 series
    HP DeskJet 690C      pcl-690    HP DeskJet 690 series
    HP DeskJet 692C      pcl-690    HP DeskJet 690 series
    HP DeskJet 693C      pcl-690    HP DeskJet 690 series
    HP DeskJet 694C      pcl-690    HP DeskJet 690 series
    HP DeskJet 695C      pcl-690    HP DeskJet 690 series
    HP DeskJet 697C      pcl-690    HP DeskJet 690 series
    HP DeskJet 810C      pcl-810    HP DeskJet 810C
    HP DeskJet 812C      pcl-812    HP DeskJet 812C
    HP DeskJet 815C      pcl-812    HP DeskJet 812C
    HP DeskJet 816C      pcl-812    HP DeskJet 812C
    HP DeskJet 825C      pcl-845    HP DeskJet 845C
    HP DeskJet 830C      pcl-810    HP DeskJet 810C
    HP DeskJet 832C      pcl-810    HP DeskJet 810C
    HP DeskJet 840C      pcl-840    HP DeskJet 840C
    HP DeskJet 841C      pcl-840    HP DeskJet 840C
    HP DeskJet 842C      pcl-842    HP DeskJet 842C
    HP DeskJet 843C      pcl-842    HP DeskJet 842C
    HP DeskJet 845C      pcl-845    HP DeskJet 845C
    HP DeskJet 850C      pcl-850    HP DeskJet 850C
    HP DeskJet 855C      pcl-855    HP DeskJet 855C
    HP DeskJet 870C      pcl-870    HP DeskJet 870C
    HP DeskJet 880C      pcl-810    HP DeskJet 810C
    HP DeskJet 882C      pcl-810    HP DeskJet 810C
    HP DeskJet 890C      pcl-890    HP DeskJet 890C
    HP DeskJet 895C      pcl-895    HP DeskJet 895C
    HP DeskJet 916C      pcl-900    HP DeskJet 900 series
    HP DeskJet 920C      pcl-900    HP DeskJet 900 series
    HP DeskJet 930C      pcl-900    HP DeskJet 900 series
    HP DeskJet 932C      pcl-900    HP DeskJet 900 series
    HP DeskJet 933C      pcl-900    HP DeskJet 900 series
    HP DeskJet 934C      pcl-900    HP DeskJet 900 series
    HP DeskJet 935C      pcl-900    HP DeskJet 900 series
    HP DeskJet 940C      pcl-900    HP DeskJet 900 series
    HP DeskJet 948C      pcl-900    HP DeskJet 900 series
    HP DeskJet 950C      pcl-900    HP DeskJet 900 series
    HP DeskJet 952C    pcl-900    HP DeskJet 900 series
    HP DeskJet 955C    pcl-900    HP DeskJet 900 series
    HP DeskJet 957C    pcl-900    HP DeskJet 900 series
    HP DeskJet 959C    pcl-900    HP DeskJet 900 series
    HP DeskJet 960C    pcl-900    HP DeskJet 900 series
    HP DeskJet 970C    pcl-900    HP DeskJet 900 series
    HP DeskJet 975C    pcl-900    HP DeskJet 900 series
    HP DeskJet 980C    pcl-900    HP DeskJet 900 series
    HP DeskJet 990C    pcl-900    HP DeskJet 900 series
    HP DeskJet 995C    pcl-900    HP DeskJet 900 series
    HP DeskJet 1100C    pcl-1100    HP DeskJet 1100C
    HP DeskJet 1120C    pcl-1120    HP DeskJet 1120C
    HP DeskJet 1125C    pcl-1120    HP DeskJet 1120C
    HP DeskJet 1200C    pcl-1200    HP DeskJet 1200C
    HP DeskJet 1220C    pcl-1220    HP DeskJet 1220C
    HP DeskJet 1600C    pcl-1600    HP DeskJet 1600C
    HP DeskJet 1600CM   pcl-1600    HP DeskJet 1600C
    HP DeskJet 3810    pcl-900    HP DeskJet 900 series
    HP DeskJet 3816    pcl-900    HP DeskJet 900 series
    HP DeskJet 3820    pcl-900    HP DeskJet 900 series
    HP DeskJet 3822    pcl-900    HP DeskJet 900 series
    HP DeskJet 5550    pcl-900    HP DeskJet 900 series
    HP DeskJet 5551    pcl-900    HP DeskJet 900 series
    HP DeskJet 6122    pcl-900    HP DeskJet 900 series
    HP DeskJet 6127    pcl-900    HP DeskJet 900 series
    HP DeskJet 9300    pcl-900    HP DeskJet 900 series
    HP E-printer E20   pcl-601    HP DeskJet 600 series
    HP LaserJet 2      pcl-2    HP LaserJet II series
    HP LaserJet 2D     pcl-2    HP LaserJet II series
    HP LaserJet 2P     pcl-2p    HP LaserJet IIP series
    HP LaserJet 2P Plus    pcl-2p    HP LaserJet IIP series
    HP LaserJet 3      pcl-3    HP LaserJet III series
    HP LaserJet 3D     pcl-3    HP LaserJet III series
    HP LaserJet 3P w/ PCL5    pcl-4l    HP LaserJet 4L
    HP LaserJet 3P w/PS    pcl-3    HP LaserJet III series
    HP LaserJet 4      pcl-4    HP LaserJet 4 series
    HP LaserJet 4 Plus    pcl-4    HP LaserJet 4 series
    HP LaserJet 4L     pcl-4l    HP LaserJet 4L
    HP LaserJet 4M     pcl-4    HP LaserJet 4 series
    HP LaserJet 4ML    pcl-4    HP LaserJet 4 series
    HP LaserJet 4P     pcl-4    HP LaserJet 4 series
    HP LaserJet 4Si    pcl-4    HP LaserJet 4 series
    HP LaserJet 4V     pcl-4v   HP LaserJet 4V, 4Si
    HP LaserJet 5      pcl-5    HP LaserJet 5 series
    HP LaserJet 5L     pcl-4    HP LaserJet 4 series
    HP LaserJet 5M     pcl-4    HP LaserJet 4 series
    HP LaserJet 5MP    pcl-4    HP LaserJet 4 series
    HP LaserJet 5P     pcl-5    HP LaserJet 5 series
    HP LaserJet 5Si    pcl-5si    HP LaserJet 5Si
    HP LaserJet 6      pcl-6    HP LaserJet 6 series
    HP LaserJet 6L     pcl-4    HP LaserJet 4 series
    HP LaserJet 6MP    pcl-4    HP LaserJet 4 series
    HP LaserJet 6P     pcl-4    HP LaserJet 4 series
    HP LaserJet 1100   pcl-6    HP LaserJet 6 series
    HP LaserJet 1100A   pcl-6    HP LaserJet 6 series
    HP LaserJet 1150    pcl-6    HP LaserJet 6 series
    HP LaserJet 1200    pcl-6    HP LaserJet 6 series
    HP LaserJet 1220    pcl-6    HP LaserJet 6 series
    HP LaserJet 1300    pcl-6    HP LaserJet 6 series
    HP LaserJet 2100    pcl-6    HP LaserJet 6 series
    HP LaserJet 2100M   pcl-6    HP LaserJet 6 series
    HP LaserJet 2200    pcl-6    HP LaserJet 6 series
    HP LaserJet 2300    pcl-6    HP LaserJet 6 series
    HP LaserJet 3200    pcl-6    HP LaserJet 6 series
    HP LaserJet 3200m       pcl-6    HP LaserJet 6 series
    HP LaserJet 3200se      pcl-6    HP LaserJet 6 series
    HP LaserJet 3300 MFP    pcl-6    HP LaserJet 6 series
    HP LaserJet 3310 MFP    pcl-6    HP LaserJet 6 series
    HP LaserJet 3320 MFP    pcl-6    HP LaserJet 6 series
    HP LaserJet 3320N MFP   pcl-6    HP LaserJet 6 series
    HP LaserJet 3330 MFP    pcl-6    HP LaserJet 6 series
    HP LaserJet 4000     pcl-6    HP LaserJet 6 series
    HP LaserJet 4050     pcl-6    HP LaserJet 6 series
    HP LaserJet 4100     pcl-6    HP LaserJet 6 series
    HP LaserJet 4200     pcl-6    HP LaserJet 6 series
    HP LaserJet 4300     pcl-6    HP LaserJet 6 series
    HP LaserJet 5000     pcl-6    HP LaserJet 6 series
    HP LaserJet 5100     pcl-6    HP LaserJet 6 series
    HP LaserJet 8000     pcl-6    HP LaserJet 6 series
    HP LaserJet 8100     pcl-6    HP LaserJet 6 series
    HP LaserJet 8150     pcl-6    HP LaserJet 6 series
    HP LaserJet 9000     pcl-6    HP LaserJet 6 series
    HP Mopier 240        pcl-6    HP LaserJet 6 series
    HP Mopier 320        pcl-6    HP LaserJet 6 series
    HP OfficeJet         pcl-520    HP DeskJet 520
    HP OfficeJet 300    pcl-520    HP DeskJet 520
    HP OfficeJet 330    pcl-520    HP DeskJet 520
    HP OfficeJet 350    pcl-520    HP DeskJet 520
    HP OfficeJet 500    pcl-601    HP DeskJet 600 series
    HP OfficeJet 520    pcl-601    HP DeskJet 600 series
    HP OfficeJet 570    pcl-601    HP DeskJet 600 series
    HP OfficeJet 580    pcl-601    HP DeskJet 600 series
    HP OfficeJet 590    pcl-601    HP DeskJet 600 series
    HP OfficeJet 600    pcl-601    HP DeskJet 600 series
    HP OfficeJet 610    pcl-601    HP DeskJet 600 series
    HP OfficeJet 625    pcl-601    HP DeskJet 600 series
    HP OfficeJet 630    pcl-601    HP DeskJet 600 series
    HP OfficeJet 635    pcl-601    HP DeskJet 600 series
    HP OfficeJet 700    pcl-690    HP DeskJet 690 series
    HP OfficeJet 710    pcl-690    HP DeskJet 690 series
    HP OfficeJet 720    pcl-690    HP DeskJet 690 series
    HP OfficeJet 725    pcl-690    HP DeskJet 690 series
    HP OfficeJet 5105    pcl-900    HP DeskJet 900 series
    HP OfficeJet 5110    pcl-900    HP DeskJet 900 series
    HP OfficeJet 5110xi  pcl-900    HP DeskJet 900 series
    HP OfficeJet 6105    pcl-900    HP DeskJet 900 series
    HP OfficeJet 6110    pcl-900    HP DeskJet 900 series
    HP OfficeJet 7110    pcl-900    HP DeskJet 900 series
    HP OfficeJet 7130    pcl-900    HP DeskJet 900 series
    HP OfficeJet 7140    pcl-900    HP DeskJet 900 series
    HP OfficeJet D125    pcl-900    HP DeskJet 900 series
    HP OfficeJet D135    pcl-900    HP DeskJet 900 series
    HP OfficeJet D145    pcl-900    HP DeskJet 900 series
    HP OfficeJet D155    pcl-900    HP DeskJet 900 series
    HP OfficeJet G55     pcl-900    HP DeskJet 900 series
    HP OfficeJet G85     pcl-900    HP DeskJet 900 series
    HP OfficeJet G95     pcl-900    HP DeskJet 900 series
    HP OfficeJet K60     pcl-900    HP DeskJet 900 series
    HP OfficeJet K60xi   pcl-900    HP DeskJet 900 series
    HP OfficeJet K80     pcl-900    HP DeskJet 900 series
    HP OfficeJet K80xi   pcl-900    HP DeskJet 900 series
    HP OfficeJet LX      pcl-520    HP DeskJet 520
    HP OfficeJet Pro 1150C    pcl-850    HP DeskJet 850C
    HP OfficeJet Pro 1170C    pcl-890    HP DeskJet 890C
    HP OfficeJet Pro 1175C    pcl-890    HP DeskJet 890C
    HP OfficeJet R40     pcl-810    HP DeskJet 810C
    HP OfficeJet R45     pcl-810    HP DeskJet 810C
    HP OfficeJet R60     pcl-810    HP DeskJet 810C
    HP OfficeJet R65     pcl-810    HP DeskJet 810C
    HP OfficeJet R80     pcl-810    HP DeskJet 810C
    HP OfficeJet T45     pcl-810    HP DeskJet 810C
    HP OfficeJet T65     pcl-810    HP DeskJet 810C
    HP OfficeJet V40     pcl-900    HP DeskJet 900 series
    HP OfficeJet V40xi   pcl-900    HP DeskJet 900 series
    HP PhotoSmart P100    pcl-900    HP DeskJet 900 series
    HP PhotoSmart P130    pcl-900    HP DeskJet 900 series
    HP PhotoSmart P230    pcl-900    HP DeskJet 900 series
    HP PhotoSmart P1000   pcl-P1000    HP PhotoSmart P1000
    HP PhotoSmart P1100   pcl-P1100    HP PhotoSmart P1100
    HP PhotoSmart P1115   pcl-900    HP DeskJet 900 series
    HP PhotoSmart P1215   pcl-900    HP DeskJet 900 series
    HP PhotoSmart P1218   pcl-900    HP DeskJet 900 series
    HP PhotoSmart P1315   pcl-900    HP DeskJet 900 series
    HP PhotoSmart 7150    pcl-900    HP DeskJet 900 series
    HP PhotoSmart 7345    pcl-900    HP DeskJet 900 series
    HP PhotoSmart 7350    pcl-900    HP DeskJet 900 series
    HP PhotoSmart 7550    pcl-900    HP DeskJet 900 series
    HP PSC 370      pcl-690    HP DeskJet 690 series
    HP PSC 380      pcl-690    HP DeskJet 690 series
    HP PSC 500      pcl-810    HP DeskJet 810C
    HP PSC 750      pcl-900    HP DeskJet 900 series
    HP PSC 950      pcl-900    HP DeskJet 900 series
    HP PSC 950xi    pcl-900    HP DeskJet 900 series
    HP PSC 2110     pcl-900    HP DeskJet 900 series
    HP PSC 2150     pcl-900    HP DeskJet 900 series
    HP PSC 2210     pcl-900    HP DeskJet 900 series

    IBM 4019                 pcl-2    HP LaserJet II series
    IBM 4029 030 LaserPrinter 10    pcl-3    HP LaserJet III series
    IBM 4312                 pcl-4    HP LaserJet 4 series
    IBM Infoprint 12         pcl-6    HP LaserJet 6 series
    IBM Page Printer 3112    pcl-4    HP LaserJet 4 series

    Infotec 4651 MF    pcl-6    HP LaserJet 6 series

    Kyocera F-1010           pcl-2    HP LaserJet II series
    Kyocera FS-600           pcl-4    HP LaserJet 4 series
    Kyocera FS-600 KPDL 2    pcl-4    HP LaserJet 4 series
    Kyocera FS-680           pcl-4    HP LaserJet 4 series
    Kyocera FS-800           pcl-4    HP LaserJet 4 series
    Kyocera FS-1000    pcl-4    HP LaserJet 4 series
    Kyocera FS-1000+   pcl-4    HP LaserJet 4 series
    Kyocera FS-1010    pcl-4    HP LaserJet 4 series
    Kyocera FS-1050    pcl-4    HP LaserJet 4 series
    Kyocera FS-1200    pcl-4    HP LaserJet 4 series
    Kyocera FS-1600    pcl-4    HP LaserJet 4 series
    Kyocera FS-1600+   pcl-4    HP LaserJet 4 series
    Kyocera FS-1700    pcl-4    HP LaserJet 4 series
    Kyocera FS-1700+   pcl-4    HP LaserJet 4 series
    Kyocera FS-1750    pcl-4    HP LaserJet 4 series
    Kyocera FS-1800    pcl-4    HP LaserJet 4 series
    Kyocera FS-1800+   pcl-4    HP LaserJet 4 series
    Kyocera FS-1900    pcl-4    HP LaserJet 4 series
    Kyocera FS-3500    pcl-3    HP LaserJet III series
    Kyocera FS-3600    pcl-4    HP LaserJet 4 series
    Kyocera FS-3600+   pcl-4    HP LaserJet 4 series
    Kyocera FS-3700    pcl-4    HP LaserJet 4 series
    Kyocera FS-3700+   pcl-4    HP LaserJet 4 series
    Kyocera FS-3750    pcl-6    HP LaserJet 6 series
    Kyocera FS-3800    pcl-4    HP LaserJet 4 series
    Kyocera FS-5800C   pcl-4    HP LaserJet 4 series
    Kyocera FS-5900C   pcl-4    HP LaserJet 4 series
    Kyocera FS-6500    pcl-3    HP LaserJet III series
    Kyocera FS-6500+   pcl-3    HP LaserJet III series
    Kyocera FS-6700    pcl-4    HP LaserJet 4 series
    Kyocera FS-7000    pcl-4    HP LaserJet 4 series
    Kyocera FS-7000+   pcl-4    HP LaserJet 4 series
    Kyocera FS-8000C   pcl-4    HP LaserJet 4 series
    Kyocera FS-9000    pcl-4    HP LaserJet 4 series
    Kyocera FS-9100DN  pcl-4    HP LaserJet 4 series
    Kyocera FS-9500DN  pcl-4    HP LaserJet 4 series
    Kyocera KM-1530    pcl-4    HP LaserJet 4 series
    Kyocera KM-1810    pcl-4    HP LaserJet 4 series
    Kyocera KM-2030    pcl-4    HP LaserJet 4 series
    Kyocera KM-2530    pcl-4    HP LaserJet 4 series
    Kyocera KM-3530    pcl-4    HP LaserJet 4 series
    Kyocera KM-4230    pcl-4    HP LaserJet 4 series
    Kyocera KM-4530    pcl-4    HP LaserJet 4 series
    Kyocera KM-5230    pcl-4    HP LaserJet 4 series
    Kyocera KM-5530    pcl-4    HP LaserJet 4 series
    Kyocera KM-6230    pcl-4    HP LaserJet 4 series

    Lexmark 4076             lexmark-4076   LEXMARK 4076
    Lexmark Optra E          pcl-4          HP LaserJet 4 series
    Lexmark Optra E+         pcl-4          HP LaserJet 4 series
    Lexmark Valuewriter 300  pcl-2          HP LaserJet II series
    Lexmark Z42              lexmark-z42    LEXMARK Z42
    Lexmark Z43              lexmark-z43    LEXMARK Z43
    Lexmark Z52              lexmark-z52    LEXMARK Z52
    Lexmark Z53              lexmark-z53    LEXMARK Z53

    Minolta PagePro 6     pcl-4    HP LaserJet 4 series
    Minolta PagePro 6e    pcl-4    HP LaserJet 4 series
    Minolta PagePro 6ex   pcl-4    HP LaserJet 4 series
    Minolta PagePro 8     pcl-4    HP LaserJet 4 series
    Minolta PagePro 8L    pcl-2    HP LaserJet II series
    Minolta PagePro 1100  pcl-6    HP LaserJet 6 series

    NEC SuperScript 660i   pcl-4    HP LaserJet 4 series
    NEC SuperScript 860    pcl-2    HP LaserJet II series
    NEC SuperScript 870    pcl-2    HP LaserJet II series
    NEC SuperScript 1260   pcl-2    HP LaserJet II series
    NEC SuperScript 1800   pcl-4    HP LaserJet 4 series

    Okidata OL400     pcl-2    HP LaserJet II series
    Okidata OL400e    pcl-2    HP LaserJet II series
    Okidata OL400ex   pcl-2    HP LaserJet II series
    Okidata OL410e    pcl-4    HP LaserJet 4 series
    Okidata OL600e    pcl-2    HP LaserJet II series
    Okidata OL610e/S  pcl-2    HP LaserJet II series
    Okidata OL800     pcl-2    HP LaserJet II series
    Okidata OL810ex   pcl-4    HP LaserJet 4 series
    Okidata Okipage 6e    pcl-4    HP LaserJet 4 series
    Okidata Okipage 6ex   pcl-4    HP LaserJet 4 series
    Okidata Okipage 8p    pcl-4    HP LaserJet 4 series
    Okidata Okipage 10e   pcl-4    HP LaserJet 4 series
    Okidata Okipage 10ex  pcl-4    HP LaserJet 4 series
    Okidata Okipage 14ex  pcl-4    HP LaserJet 4 series
    Okidata Super 6e      pcl-4l    HP LaserJet 4L

    Olivetti JP350S       pcl-2    HP LaserJet II series
    Olivetti PG 306       pcl-2    HP LaserJet II series

    Olympus P-300E     olympus-p300    OLYMPUS P300
    Olympus P-300U     olympus-p300    OLYMPUS P300
    Olympus P-330NE    olympus-p300    OLYMPUS P300
    Olympus P-400      olympus-p400    OLYMPUS P400

    PCPI 1030    pcl-2    HP LaserJet II series

    Panasonic KX-P4410    pcl-2    HP LaserJet II series
    Panasonic KX-P4450    pcl-3    HP LaserJet III series
    Panasonic KX-P6150    pcl-2    HP LaserJet II series
    Panasonic KX-P6500    pcl-2    HP LaserJet II series

    Raven LP-410    pcl-2    HP LaserJet II series

    Ricoh Aficio 220    pcl-6    HP LaserJet 6 series
    Ricoh Aficio 401    pcl-4    HP LaserJet 4 series
    Ricoh Aficio 700    pcl-4    HP LaserJet 4 series

    Samsung ML-85      pcl-4    HP LaserJet 4 series
    Samsung ML-4600    pcl-6    HP LaserJet 6 series
    Samsung ML-5000a   pcl-4    HP LaserJet 4 series
    Samsung ML-6000    pcl-4    HP LaserJet 4 series
    Samsung ML-6100    pcl-4    HP LaserJet 4 series
    Samsung ML-7000    pcl-6    HP LaserJet 6 series
    Samsung ML-7000N   pcl-6    HP LaserJet 6 series
    Samsung ML-7000P   pcl-6    HP LaserJet 6 series
    Samsung ML-7050    pcl-6    HP LaserJet 6 series
    Samsung QL-5100A   pcl-4    HP LaserJet 4 series
    Samsung QL-6050    pcl-4    HP LaserJet 4 series

    Seiko SpeedJET 200    pcl-2    HP LaserJet II series

    Sharp AR-161    pcl-6    HP LaserJet 6 series

    Sony IJP-V100    pcl-601        HP DeskJet 600 series
    Sony UP-DP10     sony-updp10    SONY UP-DP10

    Star LS-04             pcl-2    HP LaserJet II series
    Star LaserPrinter 8    pcl-2    HP LaserJet II series

    Tally MT908    pcl-3    HP LaserJet III series

    Xerox Able 1406        pcl-4    HP LaserJet 4 series
    Xerox DocuPrint C20    pcl-4    HP LaserJet 4 series
    Xerox DocuPrint P8e    pcl-4    HP LaserJet 4 series
    Xerox DocuPrint P12    pcl-2    HP LaserJet II series
    Xerox DocuPrint P1202  pcl-6    HP LaserJet 6 series
    Xerox DocuPrint 4508   pcl-4    HP LaserJet 4 series
    Xerox DocuPrint N4512  pcl-4    HP LaserJet 4 series
    Xerox DocuPrint N4512 PS    pcl-4    HP LaserJet 4 series
    Xerox Document Centre 400   pcl-4    HP LaserJet 4 series

    Generic PCL 4 Printer    pcl-2    HP LaserJet II series
    Generic PCL 5 Printer    pcl-4    HP LaserJet 4 series
    Generic PCL 5c Printer   pcl-4    HP LaserJet 4 series
    Generic PCL 5e Printer   pcl-4    HP LaserJet 4 series
    Generic PCL 6/PCL XL Printer    pcl-6    HP LaserJet 6 series
"
#end of test for info box.


DESTDIR="/etc/pdq/drivers/ghostscript"
PRNDRIVER=""

CURRENTPRS="`cat /etc/pdq/printrc | grep "ijs" | grep "printer" | sed -e 's/printer/ /g'|tr -d '{'|tr -d '"'|tr "/n" " "|tr -s " "`" #' fix for geany.
if [ "$CURRENTPRS" = "" ];then
 CURRENTPRS="nothing"
fi

msgexit () {
 Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --no-cancel \
 --msgbox "You have chosen to exit the Printer Wizard before completion.
You have to go right through to properly construct a printer definition
file in /etc/pdq/drivers/ghostscript/ folder.
This must be completed before you can print." 0 0
 if [ ! "$PRNDRIVER" = "" ];then
  rm -f $DESTDIR/ijs-$PRNDRIVER
 fi
 exit
}

#v2.13 get list from printers.xml file...
gxmessage -bg orange -borderless -buttons "" -center -nofocus -font "sans 14" " Puppy Printer Wizard

 Please wait, constructing printer list..." &
GXPID=$!
[ -f /tmp/gutenprintlist ] && rm -f /tmp/gutenprintlist
#[ -f /etc/gutenprintlist ] && rm -f /etc/gutenprintlist #makes upgrading easier.
if [ ! -f /etc/gutenprintlist$PUPPYVERSION ];then
 cat /usr/share/gutenprint/5/xml/printers.xml | grep '<printer name' > /tmp/printerlist.txt
 sync
 cat /tmp/printerlist.txt |
 while read ONELINE
 do
  PRNDESC="`echo -n "$ONELINE" | grep -o 'name=.*' | cut -f 2 -d '"'`" #' geany fix.
  PRNDRVR="`echo -n "$ONELINE" | grep -o 'driver=.*' | cut -f 2 -d '"'`" #' geany fix.
#  PRNMNFR="`echo -n "$ONELINE" | grep -o 'manufacturer=.*' | cut -f 2 -d '"'`" #' geany fix.
  echo -e "\"${PRNDRVR}\" \"${PRNDESC}\" \\"  >> /tmp/gutenprintlist
 done
 sort --key=2 /tmp/gutenprintlist > /etc/gutenprintlist$PUPPYVERSION
fi
sync
PRNLIST="`cat /etc/gutenprintlist${PUPPYVERSION}`"
kill $GXPID

#xmessage -timeout 120 -bg "#ff00ff" -title "Gimp-print IJS compatible printers" "$PRINFO" &

echo '#!/bin/sh' > /tmp/prnchoosedlg
echo 'PRNDRIVER="`Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --stdout \' >> /tmp/prnchoosedlg
echo ' --menubox "This Wizard enables you to choose a printer.' >> /tmp/prnchoosedlg
echo 'Printers already chosen are:' >> /tmp/prnchoosedlg
echo " ${CURRENTPRS}" >> /tmp/prnchoosedlg
echo >> /tmp/prnchoosedlg
echo 'Please highlight a printer in this list and click OK button:"  28 65 4 \' >> /tmp/prnchoosedlg
echo "${PRNLIST}" >> /tmp/prnchoosedlg
echo ' 2> /dev/null`"' >> /tmp/prnchoosedlg
echo 'RETSTAT=$?' >> /tmp/prnchoosedlg
echo 'echo -n "$PRNDRIVER" > /tmp/prndriver.txt' >> /tmp/prnchoosedlg
echo 'exit $RETSTAT' >> /tmp/prnchoosedlg

chmod 755 /tmp/prnchoosedlg
/tmp/prnchoosedlg
if [ ! $? -eq 0 ];then #=0 ok. #IF-ONE#
 msgexit
fi #PRNDRIVER    #IF-ONE#
PRNDRIVER="`cat /tmp/prndriver.txt`"

#start constructing printer definition file...
echo -en "driver \"ijs-$PRNDRIVER\" "  > $DESTDIR/ijs-$PRNDRIVER
echo '{' >> $DESTDIR/ijs-$PRNDRIVER

#now to choose print quality...
PRNQUALITY="`Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --stdout \
 --radiolist "You have chosen $PRNDRIVER.
Now to choose the print quality.
Please check the specifications in the printer User Manual
then choose a resolution for draft (low) quality printing:" 0 0 4 \
 "150dpi" "Draft for most PCL printers" off \
 "180dpi" "Draft for most inkjets" on \
 "360x180dpi" "A little bit darker for inkjets" off  2> /dev/null`"
if [ ! $? -eq 0 ];then #=0 ok. #IF-TWO#
 msgexit
fi #draft        #IF-TWO#

echo -e "
 option { 
  desc = \"print quality\" 
  var = OPTION_1 
  default_choice \"normal\" 

  choice \"draft\" { 
   value = \"Quality=${PRNQUALITY}\" 
   desc = \"draft\" 
   help = \"Fast, economical, low quality\" 
  } "    >> $DESTDIR/ijs-$PRNDRIVER

PRNQUALITY="`Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --stdout \
  --radiolist "Please choose a resolution for normal quality printing:" 0 0 4 \
  "300dpi" "Normal for basic PCL printers" off \
  "600dpi" "Normal for better PCL printers" off \
  "360dpi" "Normal for most inkjets" on  2> /dev/null`"
if [ ! $? -eq 0 ];then #=0 ok. #IF-THREE#
 msgexit
fi #normal       #IF-THREE#

echo -e "
  choice \"normal\" {
   value = \"Quality=${PRNQUALITY}\"
   desc = \"normal\"
   help = \"Normal quality printing\"
  } " >> $DESTDIR/ijs-$PRNDRIVER

PRNQUALITY="`Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --stdout \
   --radiolist "Please choose a resolution for high quality printing:" 0 0 4 \
   "300dpi" "High for crappy PCL printers" off \
   "600dpi" "High for better PCL printers" off \
   "1200dpi" "High for best PCL printers" off \
   "360dpi" "High for real cheap old inkjets" off \
   "720sw" "High for most ink jets" on \
   "720dpi" "High for Epson Stylus Pro" off \
   "1440x720sw" "High for quality ink jets" off \
   "1440x720dpi" "High for Epson Stylus Pro" off  2> /dev/null`"
if [ ! $? -eq 0 ];then #=0 ok. #IF-FOUR#
 msgexit
fi #high         #IF-FOUR#

echo -e "
  choice \"high\" {
   value = \"Quality=${PRNQUALITY}\"
   desc = \"high\"
   help = \"High quality printing\"
  } 
 } " >> $DESTDIR/ijs-$PRNDRIVER
 

PRNPAPERTYPE="`Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --stdout --no-tags \
   --radiolist "Please choose one of these to match your printer.
Note, for most printers first option is best:" 0 0 4 \
   "Coated" "Supports coated or glossy paper, most printers" on \
   "Glossy" "Supports coated or glossy paper, PCL inkjet printers" off \
   "default" "Use Printer default only, required for PCL laser printers" off 2>/dev/null`"
if [ ! $? -eq 0 ];then #=0 ok.
 msgexit
fi
if [ "$PRNPAPERTYPE" = "default" ];then
 echo -e "
	option {
		desc = \"paper type\"
		var = OPTION_2
		default_choice \"default\"
		choice \"default\" {
			value = \"\"
			desc = \"Use default paper type\"
			help = \"\"
		}
	} " >> $DESTDIR/ijs-$PRNDRIVER
else
 echo -e "
	option {
		desc = \"paper type\"
		var = OPTION_2
		default_choice \"plainpaper\"
		choice \"plainpaper\" {
			value = \",MediaType=Plain\"
			desc = \"plain paper \"
			help = \"\"
		}
		choice \"coatedpaper\" {
			value = \",MediaType=${PRNPAPERTYPE}\"
			desc = \"coated or glossy paper \"
			help = \"\"
		}
	} " >> $DESTDIR/ijs-$PRNDRIVER
fi


PRNCOLOR="`Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --stdout --no-tags \
    --radiolist "Please choose the color capability of the printer:" 0 0 4 \
    "black" "Black ink tank only" off \
    "rgb" "Red-green-blue color tank only" off \
    "black-rgb" "Black tank plus red-green-blue colors" on \
    "black-cmyk" "Black tank plus four or more colors" off 2> /dev/null`"
if [ ! $? -eq 0 ];then #=0 ok. #IF-FIVE#
 msgexit
fi #PRNCOLOR     #IF-FIVE#

echo -e "
 option {
  desc = \"Colors\"
  var = OPTION_3
  default_choice \"grayscale\"

  choice \"black\" {
   value = \"-sProcessColorModel=DeviceGray -dBitsPerSample=1\"
   desc = \"Print black and white only\"
   help = \"\"
  }

  choice \"grayscale\" {
   value = \"-sProcessColorModel=DeviceGray\"
   desc = \"Print shades of gray\"
   help = \"\"
  } " >> $DESTDIR/ijs-$PRNDRIVER

if [ ! "$PRNCOLOR" = "black" ];then #IF-SIX#
 echo -e "
  choice \"color\" {
   value = \"-sProcessColorModel=DeviceRGB\"
   desc = \"Print in RGB color\"
   help = \"\"
  } " >> $DESTDIR/ijs-$PRNDRIVER

 if [ "$PRNCOLOR" = "black-cmyk" ];then #IF-SEVEN#
  echo -e "
  choice \"hi-color\" {
   value = \"-sProcessColorModel=DeviceCMYK\"
   desc = \"Print in extra quality CMYK color\"
   help = \"\"
  } " >> $DESTDIR/ijs-$PRNDRIVER
 fi #cmyk  #IF-SEVEN#
fi #black #IF-SIX#

echo -e " } " >> $DESTDIR/ijs-$PRNDRIVER

##########
SUBFIX='$FIX_STAIRCASE'
SUBIN='$INPUT'
SUBOUT='$OUTPUT'
MORESTUFF="`cat -<<MSG1
	option {
		var = FIX_STAIRCASE;
		desc = "staircase text correction"
		choice scyes {
			value = "YES"
			desc = "fix staircased text problems"
			help = "Fixes printouts\n\t\tthat look\n\t\t\t\tlike this!"
		}
		choice scno {
			value = "NO"
			desc = "leave text alone"
		}
	}
	argument {
		var = "paper"
		desc = "paper size"
		help = "Set papersize to letter, legal, a3, a4, etc..."
		def_value = "letter"
	}			
	language_driver postscript {}    # Nothing to do...
	language_driver text {
		convert_exec = {
		     if [ "$SUBFIX" = "YES" ]; then
			sed 's/$//' $SUBIN > $SUBOUT;
		     else
			ln -s $SUBIN $SUBOUT;
		     fi
		     touch $SUBOUT.ok;  # Tell filter_exec not to invoke gs
		}
	}
`"

echo "$MORESTUFF"  >> $DESTDIR/ijs-$PRNDRIVER
##########

echo "$PRNDRIVER" | grep "pcl"
if [ $? -eq 0 ];then
 PRNMAKER="HEWLETT-PACKARD"
fi
echo "$PRNDRIVER" | grep "bjc"
if [ $? -eq 0 ];then
 PRNMAKER="CANON"
fi
echo "$PRNDRIVER" | grep "escp"
if [ $? -eq 0 ];then
 PRNMAKER="EPSON"
fi
echo "$PRNDRIVER" | grep "lexmark"
if [ $? -eq 0 ];then
 PRNMAKER="LEXMARK"
fi
echo -e "
 filter_exec {
  if ! test -e \$INPUT.ok; then
   gs \\
   -q -dBATCH -dSAFER -dNOPAUSE \\
   -sDEVICE=ijs \\
   -sIjsServer=/usr/bin/ijsgutenprint \\
   -sDeviceManufacturer=$PRNMAKER -sDeviceModel=$PRNDRIVER \\
   -dIjsUseOutputFD \\
   -sOutputFile=\$OUTPUT \\
   -sPaperSize=\$paper \\
   \$OPTION_3 \\
   \$INPUT
   if ! test -e \$OUTPUT; then 
    echo \"ABORTED: Ghostscript had no output.\" >> \$STATUS
    exit 1
   fi
  else
   ln -s \$INPUT \$OUTPUT;
  fi
 } " >> $DESTDIR/ijs-$PRNDRIVER

echo "}" >> $DESTDIR/ijs-$PRNDRIVER

PRNMODULE="`Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --stdout --no-tags\
   --radiolist "If this is a local printer, choose kernel device driver:" 0 0 4 \
"parport_pc" "Parallel port printer driver" on \
"usblp" "USB port printer driver" off \
" " "Serial port printer driver" off 2> /dev/null`"
if [ ! $? -eq 0 ];then #=0 ok.
 msgexit
fi
modprobe $PRNMODULE &

Xdialog --wmclass "printerwizard" --title "Puppy Printer Wizard" --no-cancel \
 --msgbox "The PDQ printer definition file is created in folder
$DESTDIR
The filename is: ijs-$PRNDRIVER

HOWEVER, it is not yet ready to use. The PDQ Printer Manager will
now be started, and from the \"Printer/Add printer\" menu you must
select printer ijs-$PRNDRIVER.
VERY IMPORTANT: When you select \"Printer/Add printer\" from the
menu, the first window asks for \"Printer name:\" -- be sure to
enter only ONE WORD, no spaces -- good idea to make a note of this
on a scrap piece of paper, so you do not go wrong! IMPORTANT!

After that, you must choose \"Printer/Set as default printer\"
(PDQ must have one default printer selected, otherwise most
 applications cannot print).

Click OK button to run PDQ Printer Manager..." 0 0

#v1.0.0
#exec xpdq
while [ 1 ];do
 xpdq
 if [ "`cat /etc/pdq/printrc 2>/dev/null | grep "default_printer"`" = "" ];then
  xmessage "You aint done it right.
There is no default printer selected.
Press OK to try again..."
 else
  #have to create a dummy /etc/printcap for Qt print dialog box...
  DEFAULTPRINTER="`cat /etc/pdq/printrc 2>/dev/null | grep "default_printer" | grep -v '#' | cut -f 2-5 -d " "`"
  echo '# LOCAL defaultprinter' > /etc/printcap
  echo -n "$DEFAULTPRINTER" >> /etc/printcap
  echo ':\' >> /etc/printcap
  echo ' :sh:' >> /etc/printcap
  sync
  break
 fi
done

###END###

