#!/bin/sh
#make the file mounted on /root bigger.
#if PFILE defined, then have a file.

#variables created at bootup by /initrd/usr/sbin/init...
. /etc/rc.d/PUPSTATE #v2.02
#PUPMODE=current operating configuration,
#PDEV1=the partition have booted off, DEV1FS=f.s. of PDEV1,
#PUPSFS=pup_201.sfs versioned name, stored on PDEV1, PUPSAVE=vfat,sda1,/pup_save.3fs

 #find out what modes use a pup_save.3fs file...
 case $PUPMODE in
  "7") #tmpfs (pup_rw), hd for persistent storage (pup_ro1), pup_xxx.sfs (pup_ro2).
   PERSISTMNTPT="/initrd/pup_ro1"
   CANDOIT="no"
   ;;
  "12") #pup_save.3fs (pup_rw), nothing on pup_ro1, pup_xxx.sfs (pup_ro2).
   PERSISTMNTPT="/initrd/pup_rw"
   CANDOIT="yes"
   ;;
  "13") #tmpfs (pup_rw), pup_save.3fs (pup_ro1), pup_xxx.sfs (pup_ro2).
   PERSISTMNTPT="/initrd/pup_ro1"
   CANDOIT="yes"
   ;;
  "77") #tmpfs (pup_rw), folders (pup_ro1), pup_xxx.sfs (pup_ro2).
   PERSISTMNTPT="/initrd/pup_ro1"
   CANDOIT="no"
   ;;
  *)
   CANDOIT="no"
   ;;
 esac

 if [ ! "$CANDOIT" = "yes" ];then
  xmessage -center -bg "#ffc0c0" -title "Resize personal storage file: ERROR" "Sorry, Puppy is not currently using a personal persistent
storage file. If this is the first time that you booted
Puppy, say from a live-CD, you are currently running
totally in RAM and you will be asked to create a personal
storage file when you end the session (shutdown the PC or
reboot). Note, the file will be named pup_save.3fs and
will be created in a place that you nominate.
If you have installed Puppy to hard drive, or installed
such that personal storage is an entire partition, then
you will not have a pup_save.3fs file either.
Press OK to exit..."
  exit
 fi

 #PUPSAVE="`cat /etc/rc.d/PUPSAVE`"
 [ ! "$PUPSAVE" ] && exit #precaution
 SAVEFS="`echo -n "$PUPSAVE" | cut -f 1 -d ','`"   #f.s. and partition where pup_save.3fs is located.
 SAVEPART="`echo -n "$PUPSAVE" | cut -f 2 -d ','`" # "
 SAVEFILE="`echo -n "$PUPSAVE" | cut -f 3 -d ','`"
 NAMEPFILE="`basename $SAVEFILE`"

#v2.11 remove...
#if [ "$SAVEFS" = "ntfs" ];then
# xmessage -center -bg '#ffc0c0' -title "Resize personal storage file" -buttons "EXIT:10" "Sorry, $NAMEPFILE file is in a NTFS partition and cannot be resized by Puppy.
#Note, the NTFS partition is $SAVEPART, but XP probably knows it as C: drive.
#Puppy has only limited write support to NTFS partitions and must not be used
#to create or resize files. $NAMEPFILE contains an ext2/3 filesystem, but it
#is just an ordinary file as far as the NTFS partition is concerned. Puppy
#can read and write from/to the file but not change its size due to limitation
#in Linux support of NTFS.
#
#There is a solution: EXIT from this script, exit from Puppy and boot up XP.
#From a commandline box inside XP, type this:
# c:> cd \\
# c:> fsutil file createnew pupextra 128000000
# c:> copy /b ${NAMEPFILE} ${NAMEPFILE}.bak
# c:> copy /b ${NAMEPFILE}+pupextra ${NAMEPFILE}
#The second line creates a file called pupextra, size 128 Mbytes.
#The third line is a precaution, in case something goes wrong.
#The last line concatenates them, creating a bigger $NAMEPFILE file.
#
#Puppy will check the filesize of $NAMEPFILE at bootup against the
#internal ext2/3 f.s. size and will automatically resize f.s. to fit.
#
#(Note: there is also a more radical solution to the NTFS problem --
# do not use it! XP can be installed to a FAT32 (vfat) partition.)
#
#To get out, click the EXIT button..."
# exit
#fi

SPARTMNTPT="`mount | grep "/dev/$SAVEPART" | tr -s " " | cut -f 3 -d " "`" #where SAVEPART is mntd.
HOMELOCATION="$SPARTMNTPT$SAVEFILE"
SIZEFREE=`df -m | grep "$PERSISTMNTPT" | tr -s " " | cut -f 4 -d " "` #free space in pup_save.3fs
ACTUALSIZK=`ls -sk $HOMELOCATION | tr -s " " | cut -f 1 -d " "` #total size of pup_save.3fs
if [ ! $ACTUALSIZK ];then
 ACTUALSIZK=`ls -sk $HOMELOCATION | tr -s " " | cut -f 2 -d " "`
fi
ACTUALSIZE=`expr $ACTUALSIZK \/ 1024`
PARTFREE=`df -m | grep "/dev/$SAVEPART" | tr -s " " | head -n 1 | cut -f 4 -d " "`


REPORTACTION="Welcome to the Puppy Resize personal storage file utility!"

MAINTEXT="Your personal file is $NAMEPFILE, and this contains all of your data,
configuration files, email, newsgroup cache, history files, installed
packages and so on. 

You have $SIZEFREE Mbytes free space left in $NAMEPFILE,
out of a total size of $ACTUALSIZE Mbytes.

File $NAMEPFILE is actually stored on partition $SAVEPART.
You have $PARTFREE Mbytes space left in $SAVEPART.

So, you need to make a decision. If you see that you are running
low on space in $NAMEPFILE, you can make it bigger, but of course
there must be enough space in $SAVEPART.
Note, it was reported on the Forum that $NAMEPFILE should not be
made bigger than 1GB, but I have yet to confirm this limitation.

PLEASE NOTE THAT AFTER YOU HAVE CLICKED A BUTTON BELOW, NOTHING
WILL HAPPEN. THE RESIZING OF $NAMEPFILE WILL HAPPEN AT REBOOT.

Press a button to make $NAMEPFILE bigger by that amount...
(note, this is one-way, you cannot make it smaller)"

BUTTONS="+64M:10,+128M:11,+256M:12,+512M:13,EXIT:19"


xmessage -center -bg "#c0ffff" -title "Resize personal storage file" -buttons "$BUTTONS" -file -<<MSG1
$REPORTACTION

$MAINTEXT
MSG1

REPLYX=$?

KILOBIG=
case ${REPLYX} in
   10)# 64M
    KILOBIG=65536
   ;;
   11)# 128M
    KILOBIG=131072
   ;;
   12)# 256M
    KILOBIG=262144
   ;;
   13)# 512M
    KILOBIG=524288
   ;;
   *)
    exit
   ;;
esac

echo -n "$KILOBIG" > $SPARTMNTPT/pupsaveresize.txt

xmessage -center -bg "orange" -title "Resize personal storage file" "Okay, you have chosen to increase $NAMEPFILE by $KILOBIG Kbytes,
however as the file is currently in use, it will happen at reboot.

Technical notes:
The required size increase has been written to file pupsaveresize.txt,
in partition $SAVEPART (currently mounted on $SPARTMNTPT).
File pupsaveresize.txt will be read at bootup and the resize performed
then pupsaveresize.txt will be deleted.

You can keep using Puppy. The change will only happen at reboot.
Click OK to exit..."

###END###

#notes:
#  dd if=/dev/zero bs=1k count=$KILOBIG | tee -a $HOMELOCATION > /dev/null
